#! /bin/sh

if [ -z "$TESTS" ]; then
	TESTS="passthru simple clone include attribute attribute2 attribute3 attribute-empty namespace namespace2 structure"
fi
if [ -z "$LANGUAGES" ]; then
	LANGUAGES="perl perl-sax php4 php5 python ruby c++0x"
fi

for L in $LANGUAGES; do
	for T in $TESTS; do
		printf "%-35s" "Testing $L/$T..."
		TEMPFILE=$( tempfile )

		if [ "$L" = "perl" ]; then
			perl -I../perl ../perl/$T.pl > $TEMPFILE
		fi
		if [ "$L" = "perl-sax" ]; then
			perl -I../perl-sax ../perl-sax/$T.pl > $TEMPFILE
		fi
		if [ "$L" = "php4" ]; then
			php4-cgi -q ../php4/$T.php > $TEMPFILE
		fi
		if [ "$L" = "php5" ]; then
			php5-cgi -q ../php5/$T.php > $TEMPFILE
		fi
		if [ "$L" = "python" ]; then
			python ../python/$T.py > $TEMPFILE
		fi
		if [ "$L" = "ruby" ]; then
			ruby -I../ruby ../ruby/$T.rb > $TEMPFILE
		fi
		if [ "$L" = "c++0x" ]; then
			( cd ../c++0x && make -s $T ) && ../c++0x/$T $TEMPFILE
		fi

		perl ./xml-diff.pl $TEMPFILE reference/$T.xml
		if [ $? = 0 ]; then	
			echo "passed."
		fi

		rm -f $TEMPFILE
	done
done

